const std = @import("std");

pub fn count_open_doors(number_of_doors: usize, number_of_passes: usize) usize {
    var open_doors: usize = 0;
    var i: usize = 1;
    while (i <= number_of_doors) : (i += 1) {
        var j: usize = 1;
        var toggles: usize = 0;
        while (j <= number_of_passes) : (j += 1) {
            toggles += @boolToInt(i % j == 0);
        }
        open_doors += toggles % 2;
    }
    return open_doors;
}

pub fn main() !void {
    const allocator = std.heap.page_allocator;
    const args = try std.process.argsAlloc(allocator);
    defer std.process.argsFree(allocator, args);

    if (args.len < 3) return error.ExpectedArgument;

    const number_of_doors: usize = try std.fmt.parseInt(usize, args[1], 10);
    const number_of_passes: usize = try std.fmt.parseInt(usize, args[2], 10);
    const open_doors: usize = count_open_doors(number_of_doors, number_of_passes);

    const stdout = std.io.getStdOut().writer();
    try stdout.print("{}\n", .{open_doors});
}
